function [CMTmin,kcmin,Lagmin,Rmin,Jmin]=kmeansNTS(X,K,JCmax,Lmax,MAL)

[N,P]=size(X);
Jmin=Inf;
kcmin=zeros(P,1);
Lag=zeros(P,1);
NT=N-2*Lmax;
CMTmin=zeros(NT,K);
for j=1:JCmax
    fprintf('%s\n',strcat(num2str(j),'/',num2str(JCmax)))
    %%%%%%%%%%%%
    CMT=zeros(NT,K);
    %%% initialize randomly
    kc=fix(rand(P,1)*K+1);
    kcold=zeros(P,1);
    kccount=0;
    while sum(kcold~=kc)>0
        %%%%%%%%%%%%%%
        % common trend
        %%%%%%%%%%%%%%%
        for k=1:K
            Y=[];
            Py=0;
            for p=1:P
                if kc(p)==k
                    Y=[Y X(:,p)];
                    Py=Py+1;
                end
            end
            if Py==0
                CMT(:,k)=zeros(NT,1);
            else
                CMT(:,k)=CommonTrendNTS(Y,Lmax,MAL);
            end
        end
        %%%%%%%%%%%%%%%
        kcold=kc;
        Jv=0;
        %% 
        Lag=zeros(P,1);
        R=zeros(P,1);
        for p=1:P
            J=zeros(K,1);
            lagtmp=J;
            Rtmp=J;
            for k=1:K
                x=CMT(:,k);
                y=X(:,p);
                [sm,r,lag]=fun_dsmT(x,y,Lmax);
                J(k)=sm;
                lagtmp(k)=lag;
                Rtmp(k)=r;
            end
            [tmp,ind]=sort(J);
            Lag(p)=lagtmp(ind(1));
            R(p)=Rtmp(ind(1));
            kc(p)=ind(1);
            Jv=Jv+tmp(1);
        end
        kccount=kccount+1;
        if kccount>50
            disp 'kccount>50'
            % it will occur when periodic (rare but possible)
            break
        end
    end
    if Jv<Jmin
        Jmin=Jv;
        kcmin=kc;
        CMTmin=CMT;
        Lagmin=Lag;
        Rmin=R;
    end
    %%%%%%%%%%%%
end

